com.amazonaws.services.machinelearning

## Interface AmazonMachineLearningAsync

All Superinterfaces:
  AmazonMachineLearning

All Known Implementing Classes:
  AbstractAmazonMachineLearningAsync, AmazonMachineLearningAsyncClient

    public interface AmazonMachineLearningAsync
    extends AmazonMachineLearning

Interface for accessing Amazon Machine Learning asynchronously. Each asynchronous method will return a Java Future object representing the asynchronous operation; overloads which accept an `AsyncHandler` can be used to receive notification when an asynchronous operation completes.

Note: Do not directly implement this interface, new methods are added to it regularly. Extend from `AbstractAmazonMachineLearningAsync` instead.

Definition of the public APIs exposed by Amazon Machine Learning

### Field Summary

### Fields inherited from interface com.amazonaws.services.machinelearning.AmazonMachineLearning

`ENDPOINT_PREFIX`

### Method Summary

All Methods Instance Methods Abstract Methods
`Future<AddTagsResult>` `addTagsAsync(AddTagsRequest addTagsRequest)` Adds one or more tags to an object, up to a limit of 10.
`Future<AddTagsResult>` `addTagsAsync(AddTagsRequest addTagsRequest, AsyncHandler<AddTagsRequest,AddTagsResult> asyncHandler)` Adds one or more tags to an object, up to a limit of 10.
`Future<CreateBatchPredictionResult>` `createBatchPredictionAsync(CreateBatchPredictionRequest createBatchPredictionRequest)` Generates predictions for a group of observations.
`Future<CreateBatchPredictionResult>` `createBatchPredictionAsync(CreateBatchPredictionRequest createBatchPredictionRequest, AsyncHandler<CreateBatchPredictionRequest,CreateBatchPredictionResult> asyncHandler)` Generates predictions for a group of observations.
`Future<CreateDataSourceFromRDSResult>` `createDataSourceFromRDSAsync(CreateDataSourceFromRDSRequest createDataSourceFromRDSRequest)` Creates a `DataSource` object from an Amazon Relational Database Service (Amazon RDS).
`Future<CreateDataSourceFromRDSResult>` `createDataSourceFromRDSAsync(CreateDataSourceFromRDSRequest createDataSourceFromRDSRequest, AsyncHandler<CreateDataSourceFromRDSRequest,CreateDataSourceFromRDSResult> asyncHandler)` Creates a `DataSource` object from an Amazon Relational Database Service (Amazon RDS).
`Future<CreateDataSourceFromRedshiftResult>` `createDataSourceFromRedshiftAsync(CreateDataSourceFromRedshiftRequest createDataSourceFromRedshiftRequest)` Creates a `DataSource` from a database hosted on an Amazon Redshift cluster.
`Future<CreateDataSourceFromRedshiftResult>` `createDataSourceFromRedshiftAsync(CreateDataSourceFromRedshiftRequest createDataSourceFromRedshiftRequest, AsyncHandler<CreateDataSourceFromRedshiftRequest,CreateDataSourceFromRedshiftResult> asyncHandler)` Creates a `DataSource` from a database hosted on an Amazon Redshift cluster.
`Future<CreateDataSourceFromS3Result>` `createDataSourceFromS3Async(CreateDataSourceFromS3Request createDataSourceFromS3Request)` Creates a `DataSource` object.
`Future<CreateDataSourceFromS3Result>` `createDataSourceFromS3Async(CreateDataSourceFromS3Request createDataSourceFromS3Request, AsyncHandler<CreateDataSourceFromS3Request,CreateDataSourceFromS3Result> asyncHandler)` Creates a `DataSource` object.
`Future<CreateEvaluationResult>` `createEvaluationAsync(CreateEvaluationRequest createEvaluationRequest)` Creates a new `Evaluation` of an `MLModel`.
`Future<CreateEvaluationResult>` `createEvaluationAsync(CreateEvaluationRequest createEvaluationRequest, AsyncHandler<CreateEvaluationRequest,CreateEvaluationResult> asyncHandler)` Creates a new `Evaluation` of an `MLModel`.
`Future<CreateMLModelResult>` `createMLModelAsync(CreateMLModelRequest createMLModelRequest)` Creates a new `MLModel` using the `DataSource` and the recipe as information sources.
`Future<CreateMLModelResult>` `createMLModelAsync(CreateMLModelRequest createMLModelRequest, AsyncHandler<CreateMLModelRequest,CreateMLModelResult> asyncHandler)` Creates a new `MLModel` using the `DataSource` and the recipe as information sources.
`Future<CreateRealtimeEndpointResult>` `createRealtimeEndpointAsync(CreateRealtimeEndpointRequest createRealtimeEndpointRequest)` Creates a real-time endpoint for the `MLModel`.
`Future<CreateRealtimeEndpointResult>` `createRealtimeEndpointAsync(CreateRealtimeEndpointRequest createRealtimeEndpointRequest, AsyncHandler<CreateRealtimeEndpointRequest,CreateRealtimeEndpointResult> asyncHandler)` Creates a real-time endpoint for the `MLModel`.
`Future<DeleteBatchPredictionResult>` `deleteBatchPredictionAsync(DeleteBatchPredictionRequest deleteBatchPredictionRequest)` Assigns the DELETED status to a `BatchPrediction`, rendering it unusable.
`Future<DeleteBatchPredictionResult>` `deleteBatchPredictionAsync(DeleteBatchPredictionRequest deleteBatchPredictionRequest, AsyncHandler<DeleteBatchPredictionRequest,DeleteBatchPredictionResult> asyncHandler)` Assigns the DELETED status to a `BatchPrediction`, rendering it unusable.
`Future<DeleteDataSourceResult>` `deleteDataSourceAsync(DeleteDataSourceRequest deleteDataSourceRequest)` Assigns the DELETED status to a `DataSource`, rendering it unusable.
`Future<DeleteDataSourceResult>` `deleteDataSourceAsync(DeleteDataSourceRequest deleteDataSourceRequest, AsyncHandler<DeleteDataSourceRequest,DeleteDataSourceResult> asyncHandler)` Assigns the DELETED status to a `DataSource`, rendering it unusable.
`Future<DeleteEvaluationResult>` `deleteEvaluationAsync(DeleteEvaluationRequest deleteEvaluationRequest)` Assigns the `DELETED` status to an `Evaluation`, rendering it unusable.
`Future<DeleteEvaluationResult>` `deleteEvaluationAsync(DeleteEvaluationRequest deleteEvaluationRequest, AsyncHandler<DeleteEvaluationRequest,DeleteEvaluationResult> asyncHandler)` Assigns the `DELETED` status to an `Evaluation`, rendering it unusable.
`Future<DeleteMLModelResult>` `deleteMLModelAsync(DeleteMLModelRequest deleteMLModelRequest)` Assigns the `DELETED` status to an `MLModel`, rendering it unusable.
`Future<DeleteMLModelResult>` `deleteMLModelAsync(DeleteMLModelRequest deleteMLModelRequest, AsyncHandler<DeleteMLModelRequest,DeleteMLModelResult> asyncHandler)` Assigns the `DELETED` status to an `MLModel`, rendering it unusable.
`Future<DeleteRealtimeEndpointResult>` `deleteRealtimeEndpointAsync(DeleteRealtimeEndpointRequest deleteRealtimeEndpointRequest)` Deletes a real time endpoint of an `MLModel`.
`Future<DeleteRealtimeEndpointResult>` `deleteRealtimeEndpointAsync(DeleteRealtimeEndpointRequest deleteRealtimeEndpointRequest, AsyncHandler<DeleteRealtimeEndpointRequest,DeleteRealtimeEndpointResult> asyncHandler)` Deletes a real time endpoint of an `MLModel`.
`Future<DeleteTagsResult>` `deleteTagsAsync(DeleteTagsRequest deleteTagsRequest)` Deletes the specified tags associated with an ML object.
`Future<DeleteTagsResult>` `deleteTagsAsync(DeleteTagsRequest deleteTagsRequest, AsyncHandler<DeleteTagsRequest,DeleteTagsResult> asyncHandler)` Deletes the specified tags associated with an ML object.
`Future<DescribeBatchPredictionsResult>` `describeBatchPredictionsAsync()` Simplified method form for invoking the DescribeBatchPredictions operation.
`Future<DescribeBatchPredictionsResult>` `describeBatchPredictionsAsync(AsyncHandler<DescribeBatchPredictionsRequest,DescribeBatchPredictionsResult> asyncHandler)` Simplified method form for invoking the DescribeBatchPredictions operation with an AsyncHandler.
`Future<DescribeBatchPredictionsResult>` `describeBatchPredictionsAsync(DescribeBatchPredictionsRequest describeBatchPredictionsRequest)` Returns a list of `BatchPrediction` operations that match the search criteria in the request.
`Future<DescribeBatchPredictionsResult>` `describeBatchPredictionsAsync(DescribeBatchPredictionsRequest describeBatchPredictionsRequest, AsyncHandler<DescribeBatchPredictionsRequest,DescribeBatchPredictionsResult> asyncHandler)` Returns a list of `BatchPrediction` operations that match the search criteria in the request.
`Future<DescribeDataSourcesResult>` `describeDataSourcesAsync()` Simplified method form for invoking the DescribeDataSources operation.
`Future<DescribeDataSourcesResult>` `describeDataSourcesAsync(AsyncHandler<DescribeDataSourcesRequest,DescribeDataSourcesResult> asyncHandler)` Simplified method form for invoking the DescribeDataSources operation with an AsyncHandler.
`Future<DescribeDataSourcesResult>` `describeDataSourcesAsync(DescribeDataSourcesRequest describeDataSourcesRequest)` Returns a list of `DataSource` that match the search criteria in the request.
`Future<DescribeDataSourcesResult>` `describeDataSourcesAsync(DescribeDataSourcesRequest describeDataSourcesRequest, AsyncHandler<DescribeDataSourcesRequest,DescribeDataSourcesResult> asyncHandler)` Returns a list of `DataSource` that match the search criteria in the request.
`Future<DescribeEvaluationsResult>` `describeEvaluationsAsync()` Simplified method form for invoking the DescribeEvaluations operation.
`Future<DescribeEvaluationsResult>` `describeEvaluationsAsync(AsyncHandler<DescribeEvaluationsRequest,DescribeEvaluationsResult> asyncHandler)` Simplified method form for invoking the DescribeEvaluations operation with an AsyncHandler.
`Future<DescribeEvaluationsResult>` `describeEvaluationsAsync(DescribeEvaluationsRequest describeEvaluationsRequest)` Returns a list of `DescribeEvaluations` that match the search criteria in the request.
`Future<DescribeEvaluationsResult>` `describeEvaluationsAsync(DescribeEvaluationsRequest describeEvaluationsRequest, AsyncHandler<DescribeEvaluationsRequest,DescribeEvaluationsResult> asyncHandler)` Returns a list of `DescribeEvaluations` that match the search criteria in the request.
`Future<DescribeMLModelsResult>` `describeMLModelsAsync()` Simplified method form for invoking the DescribeMLModels operation.
`Future<DescribeMLModelsResult>` `describeMLModelsAsync(AsyncHandler<DescribeMLModelsRequest,DescribeMLModelsResult> asyncHandler)` Simplified method form for invoking the DescribeMLModels operation with an AsyncHandler.
`Future<DescribeMLModelsResult>` `describeMLModelsAsync(DescribeMLModelsRequest describeMLModelsRequest)` Returns a list of `MLModel` that match the search criteria in the request.
`Future<DescribeMLModelsResult>` `describeMLModelsAsync(DescribeMLModelsRequest describeMLModelsRequest, AsyncHandler<DescribeMLModelsRequest,DescribeMLModelsResult> asyncHandler)` Returns a list of `MLModel` that match the search criteria in the request.
`Future<DescribeTagsResult>` `describeTagsAsync(DescribeTagsRequest describeTagsRequest)` Describes one or more of the tags for your Amazon ML object.
`Future<DescribeTagsResult>` `describeTagsAsync(DescribeTagsRequest describeTagsRequest, AsyncHandler<DescribeTagsRequest,DescribeTagsResult> asyncHandler)` Describes one or more of the tags for your Amazon ML object.
`Future<GetBatchPredictionResult>` `getBatchPredictionAsync(GetBatchPredictionRequest getBatchPredictionRequest)` Returns a `BatchPrediction` that includes detailed metadata, status, and data file information for a `Batch Prediction` request.
`Future<GetBatchPredictionResult>` `getBatchPredictionAsync(GetBatchPredictionRequest getBatchPredictionRequest, AsyncHandler<GetBatchPredictionRequest,GetBatchPredictionResult> asyncHandler)` Returns a `BatchPrediction` that includes detailed metadata, status, and data file information for a `Batch Prediction` request.
`Future<GetDataSourceResult>` `getDataSourceAsync(GetDataSourceRequest getDataSourceRequest)` Returns a `DataSource` that includes metadata and data file information, as well as the current status of the `DataSource`.
`Future<GetDataSourceResult>` `getDataSourceAsync(GetDataSourceRequest getDataSourceRequest, AsyncHandler<GetDataSourceRequest,GetDataSourceResult> asyncHandler)` Returns a `DataSource` that includes metadata and data file information, as well as the current status of the `DataSource`.
`Future<GetEvaluationResult>` `getEvaluationAsync(GetEvaluationRequest getEvaluationRequest)` Returns an `Evaluation` that includes metadata as well as the current status of the `Evaluation`.
`Future<GetEvaluationResult>` `getEvaluationAsync(GetEvaluationRequest getEvaluationRequest, AsyncHandler<GetEvaluationRequest,GetEvaluationResult> asyncHandler)` Returns an `Evaluation` that includes metadata as well as the current status of the `Evaluation`.
`Future<GetMLModelResult>` `getMLModelAsync(GetMLModelRequest getMLModelRequest)` Returns an `MLModel` that includes detailed metadata, data source information, and the current status of the `MLModel`.
`Future<GetMLModelResult>` `getMLModelAsync(GetMLModelRequest getMLModelRequest, AsyncHandler<GetMLModelRequest,GetMLModelResult> asyncHandler)` Returns an `MLModel` that includes detailed metadata, data source information, and the current status of the `MLModel`.
`Future<PredictResult>` `predictAsync(PredictRequest predictRequest)` Generates a prediction for the observation using the specified `ML Model`.
`Future<PredictResult>` `predictAsync(PredictRequest predictRequest, AsyncHandler<PredictRequest,PredictResult> asyncHandler)` Generates a prediction for the observation using the specified `ML Model`.
`Future<UpdateBatchPredictionResult>` `updateBatchPredictionAsync(UpdateBatchPredictionRequest updateBatchPredictionRequest)` Updates the `BatchPredictionName` of a `BatchPrediction`.
`Future<UpdateBatchPredictionResult>` `updateBatchPredictionAsync(UpdateBatchPredictionRequest updateBatchPredictionRequest, AsyncHandler<UpdateBatchPredictionRequest,UpdateBatchPredictionResult> asyncHandler)` Updates the `BatchPredictionName` of a `BatchPrediction`.
`Future<UpdateDataSourceResult>` `updateDataSourceAsync(UpdateDataSourceRequest updateDataSourceRequest)` Updates the `DataSourceName` of a `DataSource`.
`Future<UpdateDataSourceResult>` `updateDataSourceAsync(UpdateDataSourceRequest updateDataSourceRequest, AsyncHandler<UpdateDataSourceRequest,UpdateDataSourceResult> asyncHandler)` Updates the `DataSourceName` of a `DataSource`.
`Future<UpdateEvaluationResult>` `updateEvaluationAsync(UpdateEvaluationRequest updateEvaluationRequest)` Updates the `EvaluationName` of an `Evaluation`.
`Future<UpdateEvaluationResult>` `updateEvaluationAsync(UpdateEvaluationRequest updateEvaluationRequest, AsyncHandler<UpdateEvaluationRequest,UpdateEvaluationResult> asyncHandler)` Updates the `EvaluationName` of an `Evaluation`.
`Future<UpdateMLModelResult>` `updateMLModelAsync(UpdateMLModelRequest updateMLModelRequest)` Updates the `MLModelName` and the `ScoreThreshold` of an `MLModel`.
`Future<UpdateMLModelResult>` `updateMLModelAsync(UpdateMLModelRequest updateMLModelRequest, AsyncHandler<UpdateMLModelRequest,UpdateMLModelResult> asyncHandler)` Updates the `MLModelName` and the `ScoreThreshold` of an `MLModel`.

### Methods inherited from interface com.amazonaws.services.machinelearning.AmazonMachineLearning

`addTags, createBatchPrediction, createDataSourceFromRDS, createDataSourceFromRedshift, createDataSourceFromS3, createEvaluation, createMLModel, createRealtimeEndpoint, deleteBatchPrediction, deleteDataSource, deleteEvaluation, deleteMLModel, deleteRealtimeEndpoint, deleteTags, describeBatchPredictions, describeBatchPredictions, describeDataSources, describeDataSources, describeEvaluations, describeEvaluations, describeMLModels, describeMLModels, describeTags, getBatchPrediction, getCachedResponseMetadata, getDataSource, getEvaluation, getMLModel, predict, setEndpoint, setRegion, shutdown, updateBatchPrediction, updateDataSource, updateEvaluation, updateMLModel, waiters`

### Method Detail

#### addTagsAsync

    Future<AddTagsResult> addTagsAsync(AddTagsRequest addTagsRequest)

Adds one or more tags to an object, up to a limit of 10. Each tag consists of a key and an optional value. If you add a tag using a key that is already associated with the ML object, `AddTags` updates the tag's value.

Parameters:
  `addTagsRequest` -
Returns:
  A Java Future containing the result of the AddTags operation returned by the service.

#### addTagsAsync

    Future<AddTagsResult> addTagsAsync(AddTagsRequest addTagsRequest,
                                       AsyncHandler<AddTagsRequest,AddTagsResult> asyncHandler)

Adds one or more tags to an object, up to a limit of 10. Each tag consists of a key and an optional value. If you add a tag using a key that is already associated with the ML object, `AddTags` updates the tag's value.

Parameters:
  `addTagsRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the AddTags operation returned by the service.

#### createBatchPredictionAsync

    Future<CreateBatchPredictionResult> createBatchPredictionAsync(CreateBatchPredictionRequest createBatchPredictionRequest)

Generates predictions for a group of observations. The observations to process exist in one or more data files referenced by a `DataSource`. This operation creates a new `BatchPrediction`, and uses an `MLModel` and the data files referenced by the `DataSource` as information sources.

`CreateBatchPrediction` is an asynchronous operation. In response to `CreateBatchPrediction`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `BatchPrediction` status to `PENDING`. After the `BatchPrediction` completes, Amazon ML sets the status to `COMPLETED`.

You can poll for status updates by using the GetBatchPrediction operation and checking the `Status` parameter of the result. After the `COMPLETED` status appears, the results are available in the location specified by the `OutputUri` parameter.

Parameters:
  `createBatchPredictionRequest` -
Returns:
  A Java Future containing the result of the CreateBatchPrediction operation returned by the service.

#### createBatchPredictionAsync

    Future<CreateBatchPredictionResult> createBatchPredictionAsync(CreateBatchPredictionRequest createBatchPredictionRequest,
                                                                   AsyncHandler<CreateBatchPredictionRequest,CreateBatchPredictionResult> asyncHandler)

Generates predictions for a group of observations. The observations to process exist in one or more data files referenced by a `DataSource`. This operation creates a new `BatchPrediction`, and uses an `MLModel` and the data files referenced by the `DataSource` as information sources.

`CreateBatchPrediction` is an asynchronous operation. In response to `CreateBatchPrediction`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `BatchPrediction` status to `PENDING`. After the `BatchPrediction` completes, Amazon ML sets the status to `COMPLETED`.

You can poll for status updates by using the GetBatchPrediction operation and checking the `Status` parameter of the result. After the `COMPLETED` status appears, the results are available in the location specified by the `OutputUri` parameter.

Parameters:
  `createBatchPredictionRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateBatchPrediction operation returned by the service.

#### createDataSourceFromRDSAsync

    Future<CreateDataSourceFromRDSResult> createDataSourceFromRDSAsync(CreateDataSourceFromRDSRequest createDataSourceFromRDSRequest)

Creates a `DataSource` object from an Amazon Relational Database Service (Amazon RDS). A `DataSource` references data that can be used to perform `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromRDS` is an asynchronous operation. In response to `CreateDataSourceFromRDS`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` is created and ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in the `COMPLETED` or `PENDING` state can be used only to perform `>CreateMLModel`>, `CreateEvaluation`, or `CreateBatchPrediction` operations.

If Amazon ML cannot accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

Parameters:
  `createDataSourceFromRDSRequest` -
Returns:
  A Java Future containing the result of the CreateDataSourceFromRDS operation returned by the service.

#### createDataSourceFromRDSAsync

    Future<CreateDataSourceFromRDSResult> createDataSourceFromRDSAsync(CreateDataSourceFromRDSRequest createDataSourceFromRDSRequest,
                                                                       AsyncHandler<CreateDataSourceFromRDSRequest,CreateDataSourceFromRDSResult> asyncHandler)

Creates a `DataSource` object from an Amazon Relational Database Service (Amazon RDS). A `DataSource` references data that can be used to perform `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromRDS` is an asynchronous operation. In response to `CreateDataSourceFromRDS`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` is created and ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in the `COMPLETED` or `PENDING` state can be used only to perform `>CreateMLModel`>, `CreateEvaluation`, or `CreateBatchPrediction` operations.

If Amazon ML cannot accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

Parameters:
  `createDataSourceFromRDSRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateDataSourceFromRDS operation returned by the service.

#### createDataSourceFromRedshiftAsync

    Future<CreateDataSourceFromRedshiftResult> createDataSourceFromRedshiftAsync(CreateDataSourceFromRedshiftRequest createDataSourceFromRedshiftRequest)

Creates a `DataSource` from a database hosted on an Amazon Redshift cluster. A `DataSource` references data that can be used to perform either `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromRedshift` is an asynchronous operation. In response to `CreateDataSourceFromRedshift`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` is created and ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in `COMPLETED` or `PENDING` states can be used to perform only `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

If Amazon ML can't accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

The observations should be contained in the database hosted on an Amazon Redshift cluster and should be specified by a `SelectSqlQuery` query. Amazon ML executes an `Unload` command in Amazon Redshift to transfer the result set of the `SelectSqlQuery` query to `S3StagingLocation`.

After the `DataSource` has been created, it's ready for use in evaluations and batch predictions. If you plan to use the `DataSource` to train an `MLModel`, the `DataSource` also requires a recipe. A recipe describes how each input variable will be used in training an `MLModel`. Will the variable be included or excluded from training? Will the variable be manipulated; for example, will it be combined with another variable or will it be split apart into word combinations? The recipe provides answers to these questions.

You can't change an existing datasource, but you can copy and modify the settings from an existing Amazon Redshift datasource to create a new datasource. To do so, call `GetDataSource` for an existing datasource and copy the values to a `CreateDataSource` call. Change the settings that you want to change and make sure that all required fields have the appropriate values.

Parameters:
  `createDataSourceFromRedshiftRequest` -
Returns:
  A Java Future containing the result of the CreateDataSourceFromRedshift operation returned by the service.

#### createDataSourceFromRedshiftAsync

    Future<CreateDataSourceFromRedshiftResult> createDataSourceFromRedshiftAsync(CreateDataSourceFromRedshiftRequest createDataSourceFromRedshiftRequest,
                                                                                 AsyncHandler<CreateDataSourceFromRedshiftRequest,CreateDataSourceFromRedshiftResult> asyncHandler)

Creates a `DataSource` from a database hosted on an Amazon Redshift cluster. A `DataSource` references data that can be used to perform either `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromRedshift` is an asynchronous operation. In response to `CreateDataSourceFromRedshift`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` is created and ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in `COMPLETED` or `PENDING` states can be used to perform only `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

If Amazon ML can't accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

The observations should be contained in the database hosted on an Amazon Redshift cluster and should be specified by a `SelectSqlQuery` query. Amazon ML executes an `Unload` command in Amazon Redshift to transfer the result set of the `SelectSqlQuery` query to `S3StagingLocation`.

After the `DataSource` has been created, it's ready for use in evaluations and batch predictions. If you plan to use the `DataSource` to train an `MLModel`, the `DataSource` also requires a recipe. A recipe describes how each input variable will be used in training an `MLModel`. Will the variable be included or excluded from training? Will the variable be manipulated; for example, will it be combined with another variable or will it be split apart into word combinations? The recipe provides answers to these questions.

You can't change an existing datasource, but you can copy and modify the settings from an existing Amazon Redshift datasource to create a new datasource. To do so, call `GetDataSource` for an existing datasource and copy the values to a `CreateDataSource` call. Change the settings that you want to change and make sure that all required fields have the appropriate values.

Parameters:
  `createDataSourceFromRedshiftRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateDataSourceFromRedshift operation returned by the service.

#### createDataSourceFromS3Async

    Future<CreateDataSourceFromS3Result> createDataSourceFromS3Async(CreateDataSourceFromS3Request createDataSourceFromS3Request)

Creates a `DataSource` object. A `DataSource` references data that can be used to perform `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromS3` is an asynchronous operation. In response to `CreateDataSourceFromS3`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` has been created and is ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in the `COMPLETED` or `PENDING` state can be used to perform only `CreateMLModel`, `CreateEvaluation` or `CreateBatchPrediction` operations.

If Amazon ML can't accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

The observation data used in a `DataSource` should be ready to use; that is, it should have a consistent structure, and missing data values should be kept to a minimum. The observation data must reside in one or more .csv files in an Amazon Simple Storage Service (Amazon S3) location, along with a schema that describes the data items by name and type. The same schema must be used for all of the data files referenced by the `DataSource`.

After the `DataSource` has been created, it's ready to use in evaluations and batch predictions. If you plan to use the `DataSource` to train an `MLModel`, the `DataSource` also needs a recipe. A recipe describes how each input variable will be used in training an `MLModel`. Will the variable be included or excluded from training? Will the variable be manipulated; for example, will it be combined with another variable or will it be split apart into word combinations? The recipe provides answers to these questions.

Parameters:
  `createDataSourceFromS3Request` -
Returns:
  A Java Future containing the result of the CreateDataSourceFromS3 operation returned by the service.

#### createDataSourceFromS3Async

    Future<CreateDataSourceFromS3Result> createDataSourceFromS3Async(CreateDataSourceFromS3Request createDataSourceFromS3Request,
                                                                     AsyncHandler<CreateDataSourceFromS3Request,CreateDataSourceFromS3Result> asyncHandler)

Creates a `DataSource` object. A `DataSource` references data that can be used to perform `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromS3` is an asynchronous operation. In response to `CreateDataSourceFromS3`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` has been created and is ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in the `COMPLETED` or `PENDING` state can be used to perform only `CreateMLModel`, `CreateEvaluation` or `CreateBatchPrediction` operations.

If Amazon ML can't accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

The observation data used in a `DataSource` should be ready to use; that is, it should have a consistent structure, and missing data values should be kept to a minimum. The observation data must reside in one or more .csv files in an Amazon Simple Storage Service (Amazon S3) location, along with a schema that describes the data items by name and type. The same schema must be used for all of the data files referenced by the `DataSource`.

After the `DataSource` has been created, it's ready to use in evaluations and batch predictions. If you plan to use the `DataSource` to train an `MLModel`, the `DataSource` also needs a recipe. A recipe describes how each input variable will be used in training an `MLModel`. Will the variable be included or excluded from training? Will the variable be manipulated; for example, will it be combined with another variable or will it be split apart into word combinations? The recipe provides answers to these questions.

Parameters:
  `createDataSourceFromS3Request` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateDataSourceFromS3 operation returned by the service.

#### createEvaluationAsync

    Future<CreateEvaluationResult> createEvaluationAsync(CreateEvaluationRequest createEvaluationRequest)

Creates a new `Evaluation` of an `MLModel`. An `MLModel` is evaluated on a set of observations associated to a `DataSource`. Like a `DataSource` for an `MLModel`, the `DataSource` for an `Evaluation` contains values for the `Target Variable`. The `Evaluation` compares the predicted result for each observation to the actual outcome and provides a summary so that you know how effective the `MLModel` functions on the test data. Evaluation generates a relevant performance metric, such as BinaryAUC, RegressionRMSE or MulticlassAvgFScore based on the corresponding `MLModelType`: `BINARY`, `REGRESSION` or `MULTICLASS`.

`CreateEvaluation` is an asynchronous operation. In response to `CreateEvaluation`, Amazon Machine Learning (Amazon ML) immediately returns and sets the evaluation status to `PENDING`. After the `Evaluation` is created and ready for use, Amazon ML sets the status to `COMPLETED`.

You can use the `GetEvaluation` operation to check progress of the evaluation during the creation operation.

Parameters:
  `createEvaluationRequest` -
Returns:
  A Java Future containing the result of the CreateEvaluation operation returned by the service.

#### createEvaluationAsync

    Future<CreateEvaluationResult> createEvaluationAsync(CreateEvaluationRequest createEvaluationRequest,
                                                         AsyncHandler<CreateEvaluationRequest,CreateEvaluationResult> asyncHandler)

Creates a new `Evaluation` of an `MLModel`. An `MLModel` is evaluated on a set of observations associated to a `DataSource`. Like a `DataSource` for an `MLModel`, the `DataSource` for an `Evaluation` contains values for the `Target Variable`. The `Evaluation` compares the predicted result for each observation to the actual outcome and provides a summary so that you know how effective the `MLModel` functions on the test data. Evaluation generates a relevant performance metric, such as BinaryAUC, RegressionRMSE or MulticlassAvgFScore based on the corresponding `MLModelType`: `BINARY`, `REGRESSION` or `MULTICLASS`.

`CreateEvaluation` is an asynchronous operation. In response to `CreateEvaluation`, Amazon Machine Learning (Amazon ML) immediately returns and sets the evaluation status to `PENDING`. After the `Evaluation` is created and ready for use, Amazon ML sets the status to `COMPLETED`.

You can use the `GetEvaluation` operation to check progress of the evaluation during the creation operation.

Parameters:
  `createEvaluationRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateEvaluation operation returned by the service.

#### createMLModelAsync

    Future<CreateMLModelResult> createMLModelAsync(CreateMLModelRequest createMLModelRequest)

Creates a new `MLModel` using the `DataSource` and the recipe as information sources.

An `MLModel` is nearly immutable. Users can update only the `MLModelName` and the `ScoreThreshold` in an `MLModel` without creating a new `MLModel`.

`CreateMLModel` is an asynchronous operation. In response to `CreateMLModel`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `MLModel` status to `PENDING` . After the `MLModel` has been created and ready is for use, Amazon ML sets the status to `COMPLETED`.

You can use the `GetMLModel` operation to check the progress of the `MLModel` during the creation operation.

`CreateMLModel` requires a `DataSource` with computed statistics, which can be created by setting `ComputeStatistics` to `true` in `CreateDataSourceFromRDS`, `CreateDataSourceFromS3`, or `CreateDataSourceFromRedshift` operations.

Parameters:
  `createMLModelRequest` -
Returns:
  A Java Future containing the result of the CreateMLModel operation returned by the service.

#### createMLModelAsync

    Future<CreateMLModelResult> createMLModelAsync(CreateMLModelRequest createMLModelRequest,
                                                   AsyncHandler<CreateMLModelRequest,CreateMLModelResult> asyncHandler)

Creates a new `MLModel` using the `DataSource` and the recipe as information sources.

An `MLModel` is nearly immutable. Users can update only the `MLModelName` and the `ScoreThreshold` in an `MLModel` without creating a new `MLModel`.

`CreateMLModel` is an asynchronous operation. In response to `CreateMLModel`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `MLModel` status to `PENDING` . After the `MLModel` has been created and ready is for use, Amazon ML sets the status to `COMPLETED`.

You can use the `GetMLModel` operation to check the progress of the `MLModel` during the creation operation.

`CreateMLModel` requires a `DataSource` with computed statistics, which can be created by setting `ComputeStatistics` to `true` in `CreateDataSourceFromRDS`, `CreateDataSourceFromS3`, or `CreateDataSourceFromRedshift` operations.

Parameters:
  `createMLModelRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateMLModel operation returned by the service.

#### createRealtimeEndpointAsync

    Future<CreateRealtimeEndpointResult> createRealtimeEndpointAsync(CreateRealtimeEndpointRequest createRealtimeEndpointRequest)

Creates a real-time endpoint for the `MLModel`. The endpoint contains the URI of the `MLModel`; that is, the location to send real-time prediction requests for the specified `MLModel`.

Parameters:
  `createRealtimeEndpointRequest` -
Returns:
  A Java Future containing the result of the CreateRealtimeEndpoint operation returned by the service.

#### createRealtimeEndpointAsync

    Future<CreateRealtimeEndpointResult> createRealtimeEndpointAsync(CreateRealtimeEndpointRequest createRealtimeEndpointRequest,
                                                                     AsyncHandler<CreateRealtimeEndpointRequest,CreateRealtimeEndpointResult> asyncHandler)

Creates a real-time endpoint for the `MLModel`. The endpoint contains the URI of the `MLModel`; that is, the location to send real-time prediction requests for the specified `MLModel`.

Parameters:
  `createRealtimeEndpointRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the CreateRealtimeEndpoint operation returned by the service.

#### deleteBatchPredictionAsync

    Future<DeleteBatchPredictionResult> deleteBatchPredictionAsync(DeleteBatchPredictionRequest deleteBatchPredictionRequest)

Assigns the DELETED status to a `BatchPrediction`, rendering it unusable.

After using the `DeleteBatchPrediction` operation, you can use the GetBatchPrediction operation to verify that the status of the `BatchPrediction` changed to DELETED.

Caution: The result of the `DeleteBatchPrediction` operation is irreversible.

Parameters:
  `deleteBatchPredictionRequest` -
Returns:
  A Java Future containing the result of the DeleteBatchPrediction operation returned by the service.

#### deleteBatchPredictionAsync

    Future<DeleteBatchPredictionResult> deleteBatchPredictionAsync(DeleteBatchPredictionRequest deleteBatchPredictionRequest,
                                                                   AsyncHandler<DeleteBatchPredictionRequest,DeleteBatchPredictionResult> asyncHandler)

Assigns the DELETED status to a `BatchPrediction`, rendering it unusable.

After using the `DeleteBatchPrediction` operation, you can use the GetBatchPrediction operation to verify that the status of the `BatchPrediction` changed to DELETED.

Caution: The result of the `DeleteBatchPrediction` operation is irreversible.

Parameters:
  `deleteBatchPredictionRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DeleteBatchPrediction operation returned by the service.

#### deleteDataSourceAsync

    Future<DeleteDataSourceResult> deleteDataSourceAsync(DeleteDataSourceRequest deleteDataSourceRequest)

Assigns the DELETED status to a `DataSource`, rendering it unusable.

After using the `DeleteDataSource` operation, you can use the GetDataSource operation to verify that the status of the `DataSource` changed to DELETED.

Caution: The results of the `DeleteDataSource` operation are irreversible.

Parameters:
  `deleteDataSourceRequest` -
Returns:
  A Java Future containing the result of the DeleteDataSource operation returned by the service.

#### deleteDataSourceAsync

    Future<DeleteDataSourceResult> deleteDataSourceAsync(DeleteDataSourceRequest deleteDataSourceRequest,
                                                         AsyncHandler<DeleteDataSourceRequest,DeleteDataSourceResult> asyncHandler)

Assigns the DELETED status to a `DataSource`, rendering it unusable.

After using the `DeleteDataSource` operation, you can use the GetDataSource operation to verify that the status of the `DataSource` changed to DELETED.

Caution: The results of the `DeleteDataSource` operation are irreversible.

Parameters:
  `deleteDataSourceRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DeleteDataSource operation returned by the service.

#### deleteEvaluationAsync

    Future<DeleteEvaluationResult> deleteEvaluationAsync(DeleteEvaluationRequest deleteEvaluationRequest)

Assigns the `DELETED` status to an `Evaluation`, rendering it unusable.

After invoking the `DeleteEvaluation` operation, you can use the `GetEvaluation` operation to verify that the status of the `Evaluation` changed to `DELETED`.

<caution>Caution

The results of the `DeleteEvaluation` operation are irreversible.

</caution>

Parameters:
  `deleteEvaluationRequest` -
Returns:
  A Java Future containing the result of the DeleteEvaluation operation returned by the service.

#### deleteEvaluationAsync

    Future<DeleteEvaluationResult> deleteEvaluationAsync(DeleteEvaluationRequest deleteEvaluationRequest,
                                                         AsyncHandler<DeleteEvaluationRequest,DeleteEvaluationResult> asyncHandler)

Assigns the `DELETED` status to an `Evaluation`, rendering it unusable.

After invoking the `DeleteEvaluation` operation, you can use the `GetEvaluation` operation to verify that the status of the `Evaluation` changed to `DELETED`.

<caution>Caution

The results of the `DeleteEvaluation` operation are irreversible.

</caution>

Parameters:
  `deleteEvaluationRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DeleteEvaluation operation returned by the service.

#### deleteMLModelAsync

    Future<DeleteMLModelResult> deleteMLModelAsync(DeleteMLModelRequest deleteMLModelRequest)

Assigns the `DELETED` status to an `MLModel`, rendering it unusable.

After using the `DeleteMLModel` operation, you can use the `GetMLModel` operation to verify that the status of the `MLModel` changed to DELETED.

Caution: The result of the `DeleteMLModel` operation is irreversible.

Parameters:
  `deleteMLModelRequest` -
Returns:
  A Java Future containing the result of the DeleteMLModel operation returned by the service.

#### deleteMLModelAsync

    Future<DeleteMLModelResult> deleteMLModelAsync(DeleteMLModelRequest deleteMLModelRequest,
                                                   AsyncHandler<DeleteMLModelRequest,DeleteMLModelResult> asyncHandler)

Assigns the `DELETED` status to an `MLModel`, rendering it unusable.

After using the `DeleteMLModel` operation, you can use the `GetMLModel` operation to verify that the status of the `MLModel` changed to DELETED.

Caution: The result of the `DeleteMLModel` operation is irreversible.

Parameters:
  `deleteMLModelRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DeleteMLModel operation returned by the service.

#### deleteRealtimeEndpointAsync

    Future<DeleteRealtimeEndpointResult> deleteRealtimeEndpointAsync(DeleteRealtimeEndpointRequest deleteRealtimeEndpointRequest)

Deletes a real time endpoint of an `MLModel`.

Parameters:
  `deleteRealtimeEndpointRequest` -
Returns:
  A Java Future containing the result of the DeleteRealtimeEndpoint operation returned by the service.

#### deleteRealtimeEndpointAsync

    Future<DeleteRealtimeEndpointResult> deleteRealtimeEndpointAsync(DeleteRealtimeEndpointRequest deleteRealtimeEndpointRequest,
                                                                     AsyncHandler<DeleteRealtimeEndpointRequest,DeleteRealtimeEndpointResult> asyncHandler)

Deletes a real time endpoint of an `MLModel`.

Parameters:
  `deleteRealtimeEndpointRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DeleteRealtimeEndpoint operation returned by the service.

#### deleteTagsAsync

    Future<DeleteTagsResult> deleteTagsAsync(DeleteTagsRequest deleteTagsRequest)

Deletes the specified tags associated with an ML object. After this operation is complete, you can't recover deleted tags.

If you specify a tag that doesn't exist, Amazon ML ignores it.

Parameters:
  `deleteTagsRequest` -
Returns:
  A Java Future containing the result of the DeleteTags operation returned by the service.

#### deleteTagsAsync

    Future<DeleteTagsResult> deleteTagsAsync(DeleteTagsRequest deleteTagsRequest,
                                             AsyncHandler<DeleteTagsRequest,DeleteTagsResult> asyncHandler)

Deletes the specified tags associated with an ML object. After this operation is complete, you can't recover deleted tags.

If you specify a tag that doesn't exist, Amazon ML ignores it.

Parameters:
  `deleteTagsRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DeleteTags operation returned by the service.

#### describeBatchPredictionsAsync

    Future<DescribeBatchPredictionsResult> describeBatchPredictionsAsync(DescribeBatchPredictionsRequest describeBatchPredictionsRequest)

Returns a list of `BatchPrediction` operations that match the search criteria in the request.

Parameters:
  `describeBatchPredictionsRequest` -
Returns:
  A Java Future containing the result of the DescribeBatchPredictions operation returned by the service.

#### describeBatchPredictionsAsync

    Future<DescribeBatchPredictionsResult> describeBatchPredictionsAsync(DescribeBatchPredictionsRequest describeBatchPredictionsRequest,
                                                                         AsyncHandler<DescribeBatchPredictionsRequest,DescribeBatchPredictionsResult> asyncHandler)

Returns a list of `BatchPrediction` operations that match the search criteria in the request.

Parameters:
  `describeBatchPredictionsRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeBatchPredictions operation returned by the service.

#### describeBatchPredictionsAsync

    Future<DescribeBatchPredictionsResult> describeBatchPredictionsAsync()

Simplified method form for invoking the DescribeBatchPredictions operation.

See Also:
  `describeBatchPredictionsAsync(DescribeBatchPredictionsRequest)`

#### describeBatchPredictionsAsync

    Future<DescribeBatchPredictionsResult> describeBatchPredictionsAsync(AsyncHandler<DescribeBatchPredictionsRequest,DescribeBatchPredictionsResult> asyncHandler)

Simplified method form for invoking the DescribeBatchPredictions operation with an AsyncHandler.

See Also:
  `describeBatchPredictionsAsync(DescribeBatchPredictionsRequest, com.amazonaws.handlers.AsyncHandler)`

#### describeDataSourcesAsync

    Future<DescribeDataSourcesResult> describeDataSourcesAsync(DescribeDataSourcesRequest describeDataSourcesRequest)

Returns a list of `DataSource` that match the search criteria in the request.

Parameters:
  `describeDataSourcesRequest` -
Returns:
  A Java Future containing the result of the DescribeDataSources operation returned by the service.

#### describeDataSourcesAsync

    Future<DescribeDataSourcesResult> describeDataSourcesAsync(DescribeDataSourcesRequest describeDataSourcesRequest,
                                                               AsyncHandler<DescribeDataSourcesRequest,DescribeDataSourcesResult> asyncHandler)

Returns a list of `DataSource` that match the search criteria in the request.

Parameters:
  `describeDataSourcesRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeDataSources operation returned by the service.

#### describeDataSourcesAsync

    Future<DescribeDataSourcesResult> describeDataSourcesAsync()

Simplified method form for invoking the DescribeDataSources operation.

See Also:
  `describeDataSourcesAsync(DescribeDataSourcesRequest)`

#### describeDataSourcesAsync

    Future<DescribeDataSourcesResult> describeDataSourcesAsync(AsyncHandler<DescribeDataSourcesRequest,DescribeDataSourcesResult> asyncHandler)

Simplified method form for invoking the DescribeDataSources operation with an AsyncHandler.

See Also:
  `describeDataSourcesAsync(DescribeDataSourcesRequest, com.amazonaws.handlers.AsyncHandler)`

#### describeEvaluationsAsync

    Future<DescribeEvaluationsResult> describeEvaluationsAsync(DescribeEvaluationsRequest describeEvaluationsRequest)

Returns a list of `DescribeEvaluations` that match the search criteria in the request.

Parameters:
  `describeEvaluationsRequest` -
Returns:
  A Java Future containing the result of the DescribeEvaluations operation returned by the service.

#### describeEvaluationsAsync

    Future<DescribeEvaluationsResult> describeEvaluationsAsync(DescribeEvaluationsRequest describeEvaluationsRequest,
                                                               AsyncHandler<DescribeEvaluationsRequest,DescribeEvaluationsResult> asyncHandler)

Returns a list of `DescribeEvaluations` that match the search criteria in the request.

Parameters:
  `describeEvaluationsRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeEvaluations operation returned by the service.

#### describeEvaluationsAsync

    Future<DescribeEvaluationsResult> describeEvaluationsAsync()

Simplified method form for invoking the DescribeEvaluations operation.

See Also:
  `describeEvaluationsAsync(DescribeEvaluationsRequest)`

#### describeEvaluationsAsync

    Future<DescribeEvaluationsResult> describeEvaluationsAsync(AsyncHandler<DescribeEvaluationsRequest,DescribeEvaluationsResult> asyncHandler)

Simplified method form for invoking the DescribeEvaluations operation with an AsyncHandler.

See Also:
  `describeEvaluationsAsync(DescribeEvaluationsRequest, com.amazonaws.handlers.AsyncHandler)`

#### describeMLModelsAsync

    Future<DescribeMLModelsResult> describeMLModelsAsync(DescribeMLModelsRequest describeMLModelsRequest)

Returns a list of `MLModel` that match the search criteria in the request.

Parameters:
  `describeMLModelsRequest` -
Returns:
  A Java Future containing the result of the DescribeMLModels operation returned by the service.

#### describeMLModelsAsync

    Future<DescribeMLModelsResult> describeMLModelsAsync(DescribeMLModelsRequest describeMLModelsRequest,
                                                         AsyncHandler<DescribeMLModelsRequest,DescribeMLModelsResult> asyncHandler)

Returns a list of `MLModel` that match the search criteria in the request.

Parameters:
  `describeMLModelsRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeMLModels operation returned by the service.

#### describeMLModelsAsync

    Future<DescribeMLModelsResult> describeMLModelsAsync()

Simplified method form for invoking the DescribeMLModels operation.

See Also:
  `describeMLModelsAsync(DescribeMLModelsRequest)`

#### describeMLModelsAsync

    Future<DescribeMLModelsResult> describeMLModelsAsync(AsyncHandler<DescribeMLModelsRequest,DescribeMLModelsResult> asyncHandler)

Simplified method form for invoking the DescribeMLModels operation with an AsyncHandler.

See Also:
  `describeMLModelsAsync(DescribeMLModelsRequest, com.amazonaws.handlers.AsyncHandler)`

#### describeTagsAsync

    Future<DescribeTagsResult> describeTagsAsync(DescribeTagsRequest describeTagsRequest)

Describes one or more of the tags for your Amazon ML object.

Parameters:
  `describeTagsRequest` -
Returns:
  A Java Future containing the result of the DescribeTags operation returned by the service.

#### describeTagsAsync

    Future<DescribeTagsResult> describeTagsAsync(DescribeTagsRequest describeTagsRequest,
                                                 AsyncHandler<DescribeTagsRequest,DescribeTagsResult> asyncHandler)

Describes one or more of the tags for your Amazon ML object.

Parameters:
  `describeTagsRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the DescribeTags operation returned by the service.

#### getBatchPredictionAsync

    Future<GetBatchPredictionResult> getBatchPredictionAsync(GetBatchPredictionRequest getBatchPredictionRequest)

Returns a `BatchPrediction` that includes detailed metadata, status, and data file information for a `Batch Prediction` request.

Parameters:
  `getBatchPredictionRequest` -
Returns:
  A Java Future containing the result of the GetBatchPrediction operation returned by the service.

#### getBatchPredictionAsync

    Future<GetBatchPredictionResult> getBatchPredictionAsync(GetBatchPredictionRequest getBatchPredictionRequest,
                                                             AsyncHandler<GetBatchPredictionRequest,GetBatchPredictionResult> asyncHandler)

Returns a `BatchPrediction` that includes detailed metadata, status, and data file information for a `Batch Prediction` request.

Parameters:
  `getBatchPredictionRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the GetBatchPrediction operation returned by the service.

#### getDataSourceAsync

    Future<GetDataSourceResult> getDataSourceAsync(GetDataSourceRequest getDataSourceRequest)

Returns a `DataSource` that includes metadata and data file information, as well as the current status of the `DataSource`.

`GetDataSource` provides results in normal or verbose format. The verbose format adds the schema description and the list of files pointed to by the DataSource to the normal format.

Parameters:
  `getDataSourceRequest` -
Returns:
  A Java Future containing the result of the GetDataSource operation returned by the service.

#### getDataSourceAsync

    Future<GetDataSourceResult> getDataSourceAsync(GetDataSourceRequest getDataSourceRequest,
                                                   AsyncHandler<GetDataSourceRequest,GetDataSourceResult> asyncHandler)

Returns a `DataSource` that includes metadata and data file information, as well as the current status of the `DataSource`.

`GetDataSource` provides results in normal or verbose format. The verbose format adds the schema description and the list of files pointed to by the DataSource to the normal format.

Parameters:
  `getDataSourceRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the GetDataSource operation returned by the service.

#### getEvaluationAsync

    Future<GetEvaluationResult> getEvaluationAsync(GetEvaluationRequest getEvaluationRequest)

Returns an `Evaluation` that includes metadata as well as the current status of the `Evaluation`.

Parameters:
  `getEvaluationRequest` -
Returns:
  A Java Future containing the result of the GetEvaluation operation returned by the service.

#### getEvaluationAsync

    Future<GetEvaluationResult> getEvaluationAsync(GetEvaluationRequest getEvaluationRequest,
                                                   AsyncHandler<GetEvaluationRequest,GetEvaluationResult> asyncHandler)

Returns an `Evaluation` that includes metadata as well as the current status of the `Evaluation`.

Parameters:
  `getEvaluationRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the GetEvaluation operation returned by the service.

#### getMLModelAsync

    Future<GetMLModelResult> getMLModelAsync(GetMLModelRequest getMLModelRequest)

Returns an `MLModel` that includes detailed metadata, data source information, and the current status of the `MLModel`.

`GetMLModel` provides results in normal or verbose format.

Parameters:
  `getMLModelRequest` -
Returns:
  A Java Future containing the result of the GetMLModel operation returned by the service.

#### getMLModelAsync

    Future<GetMLModelResult> getMLModelAsync(GetMLModelRequest getMLModelRequest,
                                             AsyncHandler<GetMLModelRequest,GetMLModelResult> asyncHandler)

Returns an `MLModel` that includes detailed metadata, data source information, and the current status of the `MLModel`.

`GetMLModel` provides results in normal or verbose format.

Parameters:
  `getMLModelRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the GetMLModel operation returned by the service.

#### predictAsync

    Future<PredictResult> predictAsync(PredictRequest predictRequest)

Generates a prediction for the observation using the specified `ML Model`.

<note>Note

Not all response parameters will be populated. Whether a response parameter is populated depends on the type of model requested.

</note>

Parameters:
  `predictRequest` -
Returns:
  A Java Future containing the result of the Predict operation returned by the service.

#### predictAsync

    Future<PredictResult> predictAsync(PredictRequest predictRequest,
                                       AsyncHandler<PredictRequest,PredictResult> asyncHandler)

Generates a prediction for the observation using the specified `ML Model`.

<note>Note

Not all response parameters will be populated. Whether a response parameter is populated depends on the type of model requested.

</note>

Parameters:
  `predictRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the Predict operation returned by the service.

#### updateBatchPredictionAsync

    Future<UpdateBatchPredictionResult> updateBatchPredictionAsync(UpdateBatchPredictionRequest updateBatchPredictionRequest)

Updates the `BatchPredictionName` of a `BatchPrediction`.

You can use the `GetBatchPrediction` operation to view the contents of the updated data element.

Parameters:
  `updateBatchPredictionRequest` -
Returns:
  A Java Future containing the result of the UpdateBatchPrediction operation returned by the service.

#### updateBatchPredictionAsync

    Future<UpdateBatchPredictionResult> updateBatchPredictionAsync(UpdateBatchPredictionRequest updateBatchPredictionRequest,
                                                                   AsyncHandler<UpdateBatchPredictionRequest,UpdateBatchPredictionResult> asyncHandler)

Updates the `BatchPredictionName` of a `BatchPrediction`.

You can use the `GetBatchPrediction` operation to view the contents of the updated data element.

Parameters:
  `updateBatchPredictionRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the UpdateBatchPrediction operation returned by the service.

#### updateDataSourceAsync

    Future<UpdateDataSourceResult> updateDataSourceAsync(UpdateDataSourceRequest updateDataSourceRequest)

Updates the `DataSourceName` of a `DataSource`.

You can use the `GetDataSource` operation to view the contents of the updated data element.

Parameters:
  `updateDataSourceRequest` -
Returns:
  A Java Future containing the result of the UpdateDataSource operation returned by the service.

#### updateDataSourceAsync

    Future<UpdateDataSourceResult> updateDataSourceAsync(UpdateDataSourceRequest updateDataSourceRequest,
                                                         AsyncHandler<UpdateDataSourceRequest,UpdateDataSourceResult> asyncHandler)

Updates the `DataSourceName` of a `DataSource`.

You can use the `GetDataSource` operation to view the contents of the updated data element.

Parameters:
  `updateDataSourceRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the UpdateDataSource operation returned by the service.

#### updateEvaluationAsync

    Future<UpdateEvaluationResult> updateEvaluationAsync(UpdateEvaluationRequest updateEvaluationRequest)

Updates the `EvaluationName` of an `Evaluation`.

You can use the `GetEvaluation` operation to view the contents of the updated data element.

Parameters:
  `updateEvaluationRequest` -
Returns:
  A Java Future containing the result of the UpdateEvaluation operation returned by the service.

#### updateEvaluationAsync

    Future<UpdateEvaluationResult> updateEvaluationAsync(UpdateEvaluationRequest updateEvaluationRequest,
                                                         AsyncHandler<UpdateEvaluationRequest,UpdateEvaluationResult> asyncHandler)

Updates the `EvaluationName` of an `Evaluation`.

You can use the `GetEvaluation` operation to view the contents of the updated data element.

Parameters:
  `updateEvaluationRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the UpdateEvaluation operation returned by the service.

#### updateMLModelAsync

    Future<UpdateMLModelResult> updateMLModelAsync(UpdateMLModelRequest updateMLModelRequest)

Updates the `MLModelName` and the `ScoreThreshold` of an `MLModel`.

You can use the `GetMLModel` operation to view the contents of the updated data element.

Parameters:
  `updateMLModelRequest` -
Returns:
  A Java Future containing the result of the UpdateMLModel operation returned by the service.

#### updateMLModelAsync

    Future<UpdateMLModelResult> updateMLModelAsync(UpdateMLModelRequest updateMLModelRequest,
                                                   AsyncHandler<UpdateMLModelRequest,UpdateMLModelResult> asyncHandler)

Updates the `MLModelName` and the `ScoreThreshold` of an `MLModel`.

You can use the `GetMLModel` operation to view the contents of the updated data element.

Parameters:
  `updateMLModelRequest` -
  `asyncHandler` - Asynchronous callback handler for events in the lifecycle of the request. Users can provide an implementation of the callback methods in this interface to receive notification of successful or unsuccessful completion of the operation.
Returns:
  A Java Future containing the result of the UpdateMLModel operation returned by the service.